# TODO

# Border Name

```pycon
>>> from table2string import Table, Themes
>>> table = [
...     ("red", "255,   0,   0"),
...     ("blue", "  0,   0, 255"),
...     ("Gray-brown-raspberry", "164,  69,  79"),
... ]
>>> kwargs = {
...     "theme": Themes.thin,
... }
>>> Table(table).print(**kwargs)
┌──────────────────────┬───────────────┐
│ red                  │ 255,   0,   0 │
├──────────────────────┼───────────────┤
│ blue                 │   0,   0, 255 │
├──────────────────────┼───────────────┤
│ Gray-brown-raspberry │ 164,  69,  79 │
└──────────────────────┴───────────────┘
>>> Table(table, name="Table Name").print(**kwargs)
┌──────────────────────────────────────┐
│              Table Name              │
├──────────────────────┬───────────────┤
│ red                  │ 255,   0,   0 │
├──────────────────────┼───────────────┤
│ blue                 │   0,   0, 255 │
├──────────────────────┼───────────────┤
│ Gray-brown-raspberry │ 164,  69,  79 │
└──────────────────────┴───────────────┘
>>> Table(table, column_names=["Name", "RGB"]).print(**kwargs)
┌──────────────────────┬───────────────┐
│         Name         │      RGB      │
├──────────────────────┼───────────────┤
│ red                  │ 255,   0,   0 │
├──────────────────────┼───────────────┤
│ blue                 │   0,   0, 255 │
├──────────────────────┼───────────────┤
│ Gray-brown-raspberry │ 164,  69,  79 │
└──────────────────────┴───────────────┘
>>> Table(table, name="Table Name", column_names=["Name", "RGB"]).print(**kwargs)
┌──────────────────────────────────────┐
│              Table Name              │
├──────────────────────┬───────────────┤
│         Name         │      RGB      │
├──────────────────────┼───────────────┤
│ red                  │ 255,   0,   0 │
├──────────────────────┼───────────────┤
│ blue                 │   0,   0, 255 │
├──────────────────────┼───────────────┤
│ Gray-brown-raspberry │ 164,  69,  79 │
└──────────────────────┴───────────────┘
>>> Table(table, border_name="Border Name").print(**kwargs)  # doctest: +SKIP
┌─Border─Name──────────┬───────────────┐
│ red                  │ 255,   0,   0 │
├──────────────────────┼───────────────┤
│ blue                 │   0,   0, 255 │
├──────────────────────┼───────────────┤
│ Gray-brown-raspberry │ 164,  69,  79 │
└──────────────────────┴───────────────┘
>>> Table(table, name="Table Name", border_name="Border Name").print(**kwargs)  # doctest: +SKIP
┌─Border─Name──────────────────────────┐    ┌──────────────────────────────────────┐
│              Table Name              │    │              Table Name              │
├──────────────────────┬───────────────┤    ├─Border─Name──────────┬───────────────┤
│ red                  │ 255,   0,   0 │    │ red                  │ 255,   0,   0 │
├──────────────────────┼───────────────┤ OR ├──────────────────────┼───────────────┤
│ blue                 │   0,   0, 255 │    │ blue                 │   0,   0, 255 │
├──────────────────────┼───────────────┤    ├──────────────────────┼───────────────┤
│ Gray-brown-raspberry │ 164,  69,  79 │    │ Gray-brown-raspberry │ 164,  69,  79 │
└──────────────────────┴───────────────┘    └──────────────────────┴───────────────┘
>>> Table(table, column_names=["Name", "RGB"], border_name="Border Name").print(**kwargs)  # doctest: +SKIP
┌─Border─Name──────────┬───────────────┐
│         Name         │      RGB      │
├──────────────────────┼───────────────┤
│ red                  │ 255,   0,   0 │
├──────────────────────┼───────────────┤
│ blue                 │   0,   0, 255 │
├──────────────────────┼───────────────┤
│ Gray-brown-raspberry │ 164,  69,  79 │
└──────────────────────┴───────────────┘
>>> Table(table, name="Table Name", column_names=["Name", "RGB"], border_name="Border Name").print(**kwargs)  # doctest: +SKIP
┌─Border─Name──────────────────────────┐    ┌──────────────────────────────────────┐    ┌──────────────────────────────────────┐
│              Table Name              │    │              Table Name              │    │              Table Name              │
├──────────────────────┬───────────────┤    ├─Border─Name──────────┬───────────────┤    ├──────────────────────┬───────────────┤
│         Name         │      RGB      │    │         Name         │      RGB      │    │         Name         │      RGB      │
├──────────────────────┼───────────────┤    ├──────────────────────┼───────────────┤    ├─Border─Name──────────┼───────────────┤
│ red                  │ 255,   0,   0 │ OR │ red                  │ 255,   0,   0 │ OR │ red                  │ 255,   0,   0 │
├──────────────────────┼───────────────┤    ├──────────────────────┼───────────────┤    ├──────────────────────┼───────────────┤
│ blue                 │   0,   0, 255 │    │ blue                 │   0,   0, 255 │    │ blue                 │   0,   0, 255 │
├──────────────────────┼───────────────┤    ├──────────────────────┼───────────────┤    ├──────────────────────┼───────────────┤
│ Gray-brown-raspberry │ 164,  69,  79 │    │ Gray-brown-raspberry │ 164,  69,  79 │    │ Gray-brown-raspberry │ 164,  69,  79 │
└──────────────────────┴───────────────┘    └──────────────────────┴───────────────┘    └──────────────────────┴───────────────┘

```

# Custom Markup & Row

```pycon
from table2string import Table, Themes, CutomAlign, CutomRow
table = [
    ("11111", "22222"),
    (CutomAlign("33", h_align="<", v_align="_"), "44444"),
    CutomRow(
        (
            "55555",
            CutomAlign(  # maybe max_width: Tuple[int, ...]
                "66666",
                h_align=">",
                v_align="-",
            ),
        ),
        max_height=6,
        maximize_height=True, 
    ),
    CutomRow(("77777", "88888"), max_height=1),
]
kwargs = {
    "h_align": "^",
    "theme": Themes.thin,
    "max_width": (9,),
    "max_height": 3,
    "maximize_height": True,
}
Table(table).print(**kwargs)
┌───────────┬───────────┐
│   11111   │   22222   │
│           │           │
│           │           │
├───────────┼───────────┤
│           │   44444   │
│           │           │
│ 33        │           │
├───────────┼───────────┤
│   55555   │           │
│           │           │
│           │     66666 │
│           │           │
│           │           │
│           │           │
├───────────┼───────────┤
│   77777   │   88888   │
└───────────┴───────────┘
```

# Table Console Editor

```pycon
console_editor(
    table,         # [(1, 2), (3, 4)]
    setitem=None,  # (row, column, new_value): table[row][column] = new_value,
    export=print,  # (table): print(table)
)
```
