from table2string import Table


def test_coefficient():
    table = Table(
        [
            (
                " " * 10,
                " " * 1,
                " " * 7,
                " " * 2,
                " " * 5,
                " " * 20,
                " " * 3000,
                " " * 3,
                " " * 30,
                " " * 50,
            ),
        ]
    )
    results = [
        f"{i / 10}: "
        + table.stringify(
            max_width=90, max_height=1, proportion_coefficient=i / 10
        ).splitlines()[0]
        for i in range(0, 11)
    ]
    assert results == [
        "0.0: +---+---+---+---+---+---+----------------------------------------------------+---+---+---+",
        "0.1: +---+---+---+---+---+---+----------------------------------------------------+---+---+---+",
        "0.2: +---+---+---+---+---+----+------------------------------------------------+----+----+----+",
        "0.3: +----+----+----+----+----+----+------------------------------------------+----+----+-----+",
        "0.4: +----+----+----+----+-----+-----+--------------------------------------+-----+-----+-----+",
        "0.5: +----+----+-----+------+------+------+---------------------------------+-----+-----+-----+",
        "0.6: +-----+-----+-----+-----+-------+-------+-----------------------------+-----+-----+------+",
        "0.7: +------+------+------+------+-------+-------+------------------------+-----+------+------+",
        "0.8: +-----+------+-------+-------+--------+--------+--------------------+------+------+------+",
        "0.9: +------+------+-------+-------+--------+---------+----------------+------+-------+-------+",
        "1.0: +------+-------+--------+--------+---------+----------+-----------+------+-------+-------+",
        # "1.1: +------+-------+--------+--------+----------+-----------+------+-------+--------+--------+",
        # "1.2: +------+-------+--------+---------+----------+------------+---+-------+--------+---------+",
        # "1.3: +-----+------+-------+----------+-----------+-------------+---+-------+--------+---------+",
        # "1.4: +-----+------+-------+---------+-----------+-------------+---+-------+--------+----------+",
        # "1.5: +-----+------+-------+---------+-----------+-------------+---+-------+--------+----------+",
        # "1.6: +---+-----+------+--------+----------+--------------+---+--------+----------+------------+",
        # "1.7: +---+----+-----+--------+-----------+--------------+---+--------+----------+-------------+",
        # "1.8: +---+---+-----+-------+----------+-------------+---+--------+------------+---------------+",
        # "1.9: +---+---+----+------+----------+--------------+---+--------+------------+----------------+",
        # "2.0: +---+---+---+-----+---------+-------------+---+---------+-------------+------------------+",
    ]
